CreateMode (Apache ZooKeeper - Server 3.7.0 API)
Date: 2021-03-17

org.apache.zookeeper

## Enum CreateMode

- java.lang.Object
- - java.lang.Enum<CreateMode>
  - - org.apache.zookeeper.CreateMode

- All Implemented Interfaces:
    Serializable, Comparable<CreateMode>

      @InterfaceAudience.Public
      public enum CreateMode
      extends Enum<CreateMode>

  CreateMode value determines how the znode is created on ZooKeeper.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `CONTAINER` The znode will be a container node.
    `EPHEMERAL` The znode will be deleted upon the client's disconnect.
    `EPHEMERAL_SEQUENTIAL` The znode will be deleted upon the client's disconnect, and its name will be appended with a monotonically increasing number.
    `PERSISTENT` The znode will not be automatically deleted upon client's disconnect.
    `PERSISTENT_SEQUENTIAL` The znode will not be automatically deleted upon client's disconnect, and its name will be appended with a monotonically increasing number.
    `PERSISTENT_SEQUENTIAL_WITH_TTL` The znode will not be automatically deleted upon client's disconnect, and its name will be appended with a monotonically increasing number.
    `PERSISTENT_WITH_TTL` The znode will not be automatically deleted upon client's disconnect.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static CreateMode` | `fromFlag(int flag)` Map an integer value to a CreateMode value
    `static CreateMode` | `fromFlag(int flag, CreateMode defaultMode)` Map an integer value to a CreateMode value
    `boolean` | `isContainer()`
    `boolean` | `isEphemeral()`
    `boolean` | `isSequential()`
    `boolean` | `isTTL()`
    `int` | `toFlag()`
    `static CreateMode` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static CreateMode[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### PERSISTENT

          public static final CreateMode PERSISTENT

      The znode will not be automatically deleted upon client's disconnect.

    - #### PERSISTENT_SEQUENTIAL

          public static final CreateMode PERSISTENT_SEQUENTIAL

      The znode will not be automatically deleted upon client's disconnect, and its name will be appended with a monotonically increasing number.

    - #### EPHEMERAL

          public static final CreateMode EPHEMERAL

      The znode will be deleted upon the client's disconnect.

    - #### EPHEMERAL_SEQUENTIAL

          public static final CreateMode EPHEMERAL_SEQUENTIAL

      The znode will be deleted upon the client's disconnect, and its name will be appended with a monotonically increasing number.

    - #### CONTAINER

          public static final CreateMode CONTAINER

      The znode will be a container node. Container nodes are special purpose nodes useful for recipes such as leader, lock, etc. When the last child of a container is deleted, the container becomes a candidate to be deleted by the server at some point in the future. Given this property, you should be prepared to get `KeeperException.NoNodeException` when creating children inside of this container node.

    - #### PERSISTENT_WITH_TTL

          public static final CreateMode PERSISTENT_WITH_TTL

      The znode will not be automatically deleted upon client's disconnect. However if the znode has not been modified within the given TTL, it will be deleted once it has no children.

    - #### PERSISTENT_SEQUENTIAL_WITH_TTL

          public static final CreateMode PERSISTENT_SEQUENTIAL_WITH_TTL

      The znode will not be automatically deleted upon client's disconnect, and its name will be appended with a monotonically increasing number. However if the znode has not been modified within the given TTL, it will be deleted once it has no children.

  - ### Method Detail

    - #### values

          public static CreateMode[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (CreateMode c : CreateMode.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static CreateMode valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### isEphemeral

          public boolean isEphemeral()

    - #### isSequential

          public boolean isSequential()

    - #### isContainer

          public boolean isContainer()

    - #### isTTL

          public boolean isTTL()

    - #### toFlag

          public int toFlag()

    - #### fromFlag

          public static CreateMode fromFlag(int flag)
                                     throws KeeperException

      Map an integer value to a CreateMode value
      Throws:
        `KeeperException`

    - #### fromFlag

          public static CreateMode fromFlag(int flag,
                                            CreateMode defaultMode)

      Map an integer value to a CreateMode value

Copyright © 2008–2021 The Apache Software Foundation. All rights reserved.